// Compiled with Borland C++ C compiler

#include <stdio.h>
#include <dos.h>
#include <dir.h>

int getinfo (char *);      // Get allocation info
void commas(long *, char *);  // Convert a long to ascii with commas
			      // and output it
long current[3];              // Current allocation information
long totals[3];               // Accumulated totals
char drive;                   // Current drive letter
char drivename[20];           // Volume label o0f current drive
char buffer[20];
int main(int argc, char **argp)
{
   int first = 0;
   int i, n;
   char *drive_ptr = (argc > 1) ? *(++argp) : "";

   if (argc == 1)++argc;
   while (--argc)
   {
      if (getinfo(drive_ptr)) // Failure
      {
         if ( (argc == 1) && !first)printf("Unknown drive %c:\n",*drive_ptr);
         drive_ptr = *(++argp);
         continue;
      }
      drive_ptr = *(++argp);
      if (!first)printf(
         "           Total              Used              Free   Disk\n");
      ++first;
	   commas(current, " %s  ");
      if (!drivename[0])strcpy(drivename, "no volume label");
      printf(" %c (%s)\n", drive, drivename);
   }
   if (first > 1)
   {
      printf("\n");
      commas(totals, " %s  ");
      printf(" Totals\n");
   }
   if (first)
   {
      for (i = 0; i < 3; i++)totals[i] /= 1024l;
      commas(totals, " %sK ");
   } 
   return(0);
}
#define LENGTH 15
void commas(long *nums, char *fmt)
{
   int count;
   long num;
   char remainder;
   char *where;
   int n;

   for (n = 0; n < 3; n++)
   {
      num = *nums++;
      for (count = 0; count < LENGTH; count++)buffer[count] = ' ';

      count = 0;

      where = &buffer[LENGTH];
      *where-- = '\0';

      *where = '0';

      while (num)
      {
         remainder = num % 10l;
         if (count == 3)
         {
            count = 0;
            *where-- = ',';
         }
         ++count;
         *where-- = remainder + '0';
         num /= 10l;
      }
      printf(fmt, buffer);
   }
}
static char scratch[] = "X:\\*.*";
static struct ffblk ff;

int getinfo(char *drive_ptr)
{
   int bytes_per_cluster;
   int clusters_per_sector;
   unsigned available;
   unsigned total;

   int n;
   int save_cx = _CX;
   char drive_code;
   
   strupr (drive_ptr);

   drive_code = *drive_ptr;

   if (drive_code)drive_code -= ('A' - '\1');
   else
   {
      _AH = 0x19;
      geninterrupt(0x21);
      drive_code = _AL + 1;
   }

   // Now go after allocation info

   _AH = 0x36;
   _DL = drive_code;
   geninterrupt(0x21);

   if (_AX == 0xffff) //Failure
   {
      _CX = save_cx;
      return (_AX);
   }

   available = _BX;
   total = _DX;
   bytes_per_cluster = _AX * _CX;
   _CX = save_cx;

   current[0] = (long)total * bytes_per_cluster;
   current[2] = (long)available * bytes_per_cluster;
   current[1] = current[0] - current[2];

   for (n = 0; n < 3; ++n)totals[n] += current[n];

   drive = drive_code + 'A' - 1;

   // Now go after volume name

   scratch[0] = drive;

   findfirst(scratch, &ff, FA_LABEL);

   strcpy(drivename, ff.ff_name);
   // Volumes are name.ext format, too; get rid of .
   if (strlen(drivename) > 8)strcpy(&drivename[8], &drivename[9]);

   return (0);
}
